<?php

namespace Ecommerce\Util;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;

class ExpiredSessionListener extends \Zeedhi\Framework\Events\PostDispatch\Listener {
    
    const LOGIN_ORIGIN = array('AUTHENTICATION');
    const EXPIRED_SESSION_ROUTE = '/lib_validateExpiredSession';
    private function isExpiredSessionRoute(DTO\Request $request){
        $route = $request->getRoutePath();
        return strpos(self::EXPIRED_SESSION_ROUTE, $route) !== false;
    }
    
    private function hasLoginOrigin(DTO\Request $request){
        $parameters = $request->getParameters();
        $origin = $parameters['origin'] ?? null;
        $containerName = $origin['containerName'] ?? null;
        return array_search($containerName, self::LOGIN_ORIGIN) !== false;
    }
    
    public function postDispatch (DTO\Request $request, DTO\Response $response) {
        if($this->isExpiredSessionRoute($request) && $this->hasLoginOrigin($request)){
            $newDataSet = new DataSet("expiredSessionInfo", array(
                "IS_EXPIRED" => false,
                "TIMEOUT" => 3600000
            ));
            $response->setDataSets(array($newDataSet));
        }
    }
}