/* Sistemas Integrados TECNISA

Nome: LOG_PARAMCST.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   14/11/2012 - Kessiler Almeida S. Rodrigues
*/

IF EXISTS(SELECT *
          FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'LOG_PARAMCST' AND
                TYPE   = 'TR'           AND
                U.UID  = O.UID          AND
                U.NAME = USER)

DROP TRIGGER LOG_PARAMCST
GO

CREATE TRIGGER LOG_PARAMCST
ON PARAMCST
FOR INSERT, UPDATE, DELETE
AS
   DECLARE @V_NMUSUARIO           VARCHAR(40);
   DECLARE @V_TIPO                VARCHAR(1);
   DECLARE @V_ITPESQ              VARCHAR(40);
   DECLARE @V_IDCOMANDO           VARCHAR(1);
   DECLARE @V_DESC                VARCHAR(500);
   DECLARE @V_DSREMOTEADDR        VARCHAR(15);
   DECLARE @V_DSREMOTEHOST        VARCHAR(15);
   DECLARE @V_DSSERVERRDM         VARCHAR(20);
   DECLARE @V_DSSERVMETHOD        VARCHAR(30);
   DECLARE @V_DSREMOTEOPER        VARCHAR(12);

   DECLARE @V_IDENTRSAIDOP_NEW    VARCHAR(1);
   DECLARE @V_CDIMPOSTO_NEW       VARCHAR(2);
   DECLARE @V_CDSITUTRIB_NEW      VARCHAR(2);
   DECLARE @V_DSSITUTRIB_NEW      VARCHAR(255);
   DECLARE @V_IDOBRVRIMPOS_NEW    VARCHAR(1);
   DECLARE @V_IDUTILIZACST_NEW    VARCHAR(1);

   DECLARE @V_IDENTRSAIDOP_OLD    VARCHAR(1);
   DECLARE @V_CDIMPOSTO_OLD       VARCHAR(2);
   DECLARE @V_CDSITUTRIB_OLD      VARCHAR(2);
   DECLARE @V_DSSITUTRIB_OLD      VARCHAR(255);
   DECLARE @V_IDOBRVRIMPOS_OLD    VARCHAR(1);
   DECLARE @V_IDUTILIZACST_OLD    VARCHAR(1);
BEGIN
   SET @V_TIPO      = '0';
   SET @V_ITPESQ    = '';
   SET @V_DESC      = '';
   SET @V_NMUSUARIO = '';

   DECLARE C_PARAMCST CURSOR FOR
      SELECT
         'D' IDCOMANDO,
	      NULL,
	      NULL,
	      NULL,
	      NULL,
         NULL,
         NULL,
         IDENTRSAIDOP,
	      CDIMPOSTO,
	      CDSITUTRIB,
	      DSSITUTRIB,
         IDOBRVRIMPOS,
         IDUTILIZACST
       FROM DELETED
      WHERE 0 = (SELECT COUNT(*) FROM INSERTED)

      UNION ALL

      SELECT
         'U' IDCOMANDO,
         INSERTED.IDENTRSAIDOP,
	      INSERTED.CDIMPOSTO,
         INSERTED.CDSITUTRIB,
	      INSERTED.DSSITUTRIB,
         INSERTED.IDOBRVRIMPOS,
         INSERTED.IDUTILIZACST,
         DELETED.IDENTRSAIDOP,
	      DELETED.CDIMPOSTO,
         DELETED.CDSITUTRIB,
	      DELETED.DSSITUTRIB,
         DELETED.IDOBRVRIMPOS,
         DELETED.IDUTILIZACST
      FROM
         INSERTED, DELETED
      WHERE
         INSERTED.IDENTRSAIDOP  = DELETED.IDENTRSAIDOP AND
         INSERTED.CDIMPOSTO     = DELETED.CDIMPOSTO

      UNION ALL

      SELECT
         'I' IDCOMANDO,
         IDENTRSAIDOP,
	      CDIMPOSTO,
	      CDSITUTRIB,
	      DSSITUTRIB,
         IDOBRVRIMPOS,
         IDUTILIZACST,
	      NULL,
	      NULL,
	      NULL,
	      NULL,
         NULL,
         NULL
       FROM
         INSERTED
      WHERE 0 = (SELECT COUNT(*) FROM DELETED)
      
   OPEN C_PARAMCST;
   FETCH NEXT FROM C_PARAMCST INTO @V_IDCOMANDO, @V_IDENTRSAIDOP_NEW, @V_CDIMPOSTO_NEW, @V_CDSITUTRIB_NEW,
                                                 @V_DSSITUTRIB_NEW, @V_IDOBRVRIMPOS_NEW, @V_IDUTILIZACST_NEW,
                                                 @V_IDENTRSAIDOP_OLD, @V_CDIMPOSTO_OLD, @V_CDSITUTRIB_OLD,
                                                 @V_DSSITUTRIB_OLD, @V_IDOBRVRIMPOS_OLD, @V_IDUTILIZACST_OLD;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_IDCOMANDO = 'D' BEGIN
         IF @V_IDENTRSAIDOP_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' E/S='             + @V_IDENTRSAIDOP_OLD;
         END;
         IF @V_CDIMPOSTO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdImposto='       + @V_CDIMPOSTO_OLD;
         END;
         IF @V_CDSITUTRIB_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdSituTrib='      + @V_CDSITUTRIB_OLD;
         END;
         IF @V_DSSITUTRIB_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DescSitTrib='     + @V_DSSITUTRIB_OLD;
         END;
         IF @V_IDOBRVRIMPOS_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdObrigaImposto=' + @V_IDOBRVRIMPOS_OLD;
         END;
         IF @V_IDUTILIZACST_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' UtilizaCST='      + @V_IDUTILIZACST_OLD;
         END;
         SET @V_TIPO   = '3';
         SET @V_ITPESQ = @V_IDENTRSAIDOP_OLD+@V_CDIMPOSTO_OLD;
      END
      ELSE BEGIN
         IF @V_IDCOMANDO = 'U' BEGIN
            IF  ISNULL(@V_IDENTRSAIDOP_OLD, '!') <> ISNULL(@V_IDENTRSAIDOP_NEW, '!') OR
                ISNULL(@V_CDIMPOSTO_OLD,    '!') <> ISNULL(@V_CDIMPOSTO_NEW,    '!') OR
                ISNULL(@V_CDSITUTRIB_OLD,   '!') <> ISNULL(@V_CDSITUTRIB_NEW,   '!') OR
                ISNULL(@V_DSSITUTRIB_OLD,   '!') <> ISNULL(@V_DSSITUTRIB_NEW,   '!') OR
                ISNULL(@V_IDOBRVRIMPOS_OLD, '!') <> ISNULL(@V_IDOBRVRIMPOS_NEW, '!') OR
                ISNULL(@V_IDUTILIZACST_OLD, '!') <> ISNULL(@V_IDUTILIZACST_NEW, '!') BEGIN
                SET @V_TIPO   = '2';
                SET @V_ITPESQ = @V_IDENTRSAIDOP_OLD+@V_CDIMPOSTO_OLD;
            END;
         END
         ELSE BEGIN
            SET @V_TIPO   = '1';
            SET @V_ITPESQ = @V_IDENTRSAIDOP_NEW+@V_CDIMPOSTO_NEW;
         END;
         IF ISNULL(@V_IDENTRSAIDOP_OLD, '!') <> ISNULL(@V_IDENTRSAIDOP_NEW, '!') BEGIN
            SET @V_DESC = @V_DESC + ' E/S='             + @V_IDENTRSAIDOP_NEW;
         END;
         IF ISNULL(@V_CDIMPOSTO_OLD,    '!') <> ISNULL(@V_CDIMPOSTO_NEW,    '!') BEGIN
            SET @V_DESC = @V_DESC + ' CdImposto='       + @V_CDIMPOSTO_NEW;
         END;
         IF ISNULL(@V_CDSITUTRIB_OLD,   '!') <> ISNULL(@V_CDSITUTRIB_NEW,   '!') BEGIN
            SET @V_DESC = @V_DESC + ' CdSituTrib='      + @V_CDSITUTRIB_NEW;
         END;
         IF ISNULL(@V_DSSITUTRIB_OLD,   '!') <> ISNULL(@V_DSSITUTRIB_NEW,   '!') BEGIN
            SET @V_DESC = @V_DESC + ' DescSitTrib='     + @V_DSSITUTRIB_NEW;
         END;
         IF ISNULL(@V_IDOBRVRIMPOS_OLD, '!') <> ISNULL(@V_IDOBRVRIMPOS_NEW, '!') BEGIN
            SET @V_DESC = @V_DESC + ' IdObrigaImposto=' + @V_IDOBRVRIMPOS_NEW;
         END;
         IF ISNULL(@V_IDUTILIZACST_OLD, '!') <> ISNULL(@V_IDUTILIZACST_NEW, '!') BEGIN
            SET @V_DESC = @V_DESC + ' UtilizaCST='      + @V_IDUTILIZACST_NEW;
         END;
      END;
      IF NOT @V_DESC IS NULL AND @V_TIPO <> '0' BEGIN
         EXEC NMUSUARIO  @P_NMUSUARIO    = @V_NMUSUARIO OUTPUT;
         EXEC WEBTUNNING @P_DSREMOTEADDR = @V_DSREMOTEADDR OUTPUT,
                         @P_DSREMOTEHOST = @V_DSREMOTEHOST OUTPUT,
                         @P_DSSERVERRDM  = @V_DSSERVERRDM  OUTPUT,
                         @P_DSSERVMETHOD = @V_DSSERVMETHOD OUTPUT,
                         @P_DSREMOTEOPER = @V_DSREMOTEOPER OUTPUT;
         SET @V_DESC = SUBSTRING(@V_DESC, 1, 300);
         INSERT INTO LOGOPERA
            (NMTABELA,
             DTOPERACAO,
             NMRESPOPER,
             IDTIPOOPER,
             DSOPERACAO,
             CDPESQITEM,
             DSRDMUSUOPER,
             DSENDUSUOPER,
             DSNMUSUOPER,
             DSMETUSUOPER,
             CDORESPOPER)
         VALUES
            ('PARAMCST',
             GETDATE(),
             ISNULL(@V_NMUSUARIO,' '),
             @V_TIPO,
             @V_DESC,
             @V_ITPESQ,
             @V_DSSERVERRDM,
             @V_DSREMOTEADDR,
             @V_DSREMOTEHOST,
             @V_DSSERVMETHOD,
             @V_DSREMOTEOPER);
      END;
      FETCH NEXT FROM C_PARAMCST INTO @V_IDCOMANDO, @V_IDENTRSAIDOP_NEW, @V_CDIMPOSTO_NEW, @V_CDSITUTRIB_NEW,
                                                    @V_DSSITUTRIB_NEW, @V_IDOBRVRIMPOS_NEW, @V_IDUTILIZACST_NEW,
                                                    @V_IDENTRSAIDOP_OLD, @V_CDIMPOSTO_OLD, @V_CDSITUTRIB_OLD,
                                                    @V_DSSITUTRIB_OLD, @V_IDOBRVRIMPOS_OLD, @V_IDUTILIZACST_OLD;
   END;
   CLOSE C_PARAMCST;
   DEALLOCATE C_PARAMCST;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_PARAMCST','5.50.xxx';
GO
